<%inherit file="/basedb/basetab" />
<%namespace name="buttons" file="/basedb/buttons2"  /> 
<% import emen2.util.jsonutil %>


<%

import collections
import operator

year = rec.get("p41_year")

%>



<script type="text/javascript">
//<![CDATA[
	$(document).ready(function() {
		$('.editable').EditControl({});
		
		$('input[name=p41include]').change(function() {
			var yearname = $(this).attr('data-yearname');
			var name = $(this).attr('data-name');
			var year = $(this).attr('data-year');
			var method = "pcunlink";
			if ($(this).attr('checked')) {
				method = "pclink";
			}
			$.jsonRPC(method, [year, name], function() {
				if (method == "pclink") {notify("Added "+name+" to "+yearname+" report")}
				if (method == "pcunlink") {notify("Removed "+name+" from the "+yearname+" report")}				
			});
		})
		
	});	
//]]>
</script>


<h1 id="p41years">Projects and Years Included</h1>

<%
p41_years_sorted = sorted(p41_years.items())
p41_included = []
p41_notincluded = []

for i in p41_index:
	inc = False
	for yrec in p41_years.values():
		if yrec.name in p41_project_parents.get(i):
			inc = True

	if inc:
		p41_included.append(i)
	else:
		p41_notincluded.append(i)
	

%>


<table>
	<thead>
		<th>Project</th>
		% for yrec_year, yrec in p41_years_sorted:
			<th><a href="${EMEN2WEBROOT}/record/${yrec.name}">${yrec_year}</a></th>
		% endfor
	</thead>
	
	<tbody>
	
	% for count, i in enumerate(sorted(p41_included, key=recnames.get)):
		
		% if count % 2:
			<tr>
		% else:
			<tr class="s">	
		% endif

			<td><a href="${EMEN2WEBROOT}/record/${i}/">${recnames.get(i)}</a></td>
			
			% for yrec_year, yrec in p41_years_sorted:
				<td>
					
					% if yrec.name in p41_project_parents.get(i):
						<input type="checkbox" name="p41include" checked="checked" data-yearname="${yrec_year}" data-name="${i}" data-year="${yrec.name}" />
					% else:
						<input type="checkbox"  name="p41include" data-name="${i}"  data-yearname="${yrec_year}" data-year="${yrec.name}" />
					% endif
					
				</td>
			% endfor
		
		</tr>
			
	% endfor


	<tr>
		<td>Projects that do not seem to be included in any year...</td>
	</tr>
	
	% for count, i in enumerate(sorted(p41_notincluded, key=recnames.get)):
		
		% if count % 2:
			<tr>
		% else:
			<tr class="s">	
		% endif

			<td><a href="${EMEN2WEBROOT}/record/${i}/">${recnames.get(i)}</a></td>
			% for yrec_year, yrec in p41_years_sorted:
				<td>
					
					% if yrec.name in p41_project_parents.get(i):
						<input type="checkbox" name="p41include" checked="checked" data-yearname="${yrec_year}" data-name="${i}" data-year="${yrec.name}" />
					% else:
						<input type="checkbox"  name="p41include" data-name="${i}"  data-yearname="${yrec_year}" data-year="${yrec.name}" />
					% endif
					
				</td>
			% endfor
		
		</tr>
			
	% endfor
	



	</tbody>

</table>
